/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package clases;

import java.io.Serializable;
import javax.persistence.*;

/**
 *
 * @author amaranto
 */
@Entity(name="PasoExcepcion")
public class Evento extends Generico implements Serializable
{
    @Id
    @GeneratedValue(strategy= GenerationType.AUTO)
    private long id;
    private String Descripcion;
    @Column(name="Numero_paso")
    private int num_paso;
    private boolean tipo;//false indica un paso, true indica excepcion
    
    @ManyToOne(optional=true)
    private Caso_de_uso pertenece;


    public Evento(){
    }

    /**
     * @return the Descripcion
     */
    public String getDescripcion() {
        return Descripcion;
    }

    /**
     * @param Descripcion the Descripcion to set
     */
    public void setDescripcion(String Descripcion) {
        this.Descripcion = Descripcion;
    }

    /**
     * @return the num_paso
     */
    public int getNum_paso() {
        return num_paso;
    }

    /**
     * @param num_paso the num_paso to set
     */
    public void setNum_paso(int num_paso) {
        this.num_paso = num_paso;
    }

    /**
     * @return the tipo
     */
    public boolean isTipo() {
        return tipo;
    }

    /**
     * @param tipo the tipo to set
     */
    public void setTipo(boolean tipo) {
        this.tipo = tipo;
    }

    public String toString()
    {
        return String.valueOf(this.num_paso);
    }

    /**
     * @return the pertenece
     */
    public Caso_de_uso getPertenece() {
        return pertenece;
    }

    /**
     * @param pertenece the pertenece to set
     */
    public void setPertenece(Caso_de_uso pertenece) {
        this.pertenece = pertenece;
    }
    
    public void grabar()
    {
        EntityManagerFactory emf = Persistence.createEntityManagerFactory("CUSL-EasyReqPU");
        EntityManager em = emf.createEntityManager();
        em.getTransaction().begin();
        try {
            em.persist(this);
            em.getTransaction().commit();
        } catch (Exception e) {
            e.printStackTrace();
            em.getTransaction().rollback();
        } finally {
            em.close();
        }
    }
    
    public static void editar(Evento evt)
    {
        EntityManagerFactory emf = Persistence.createEntityManagerFactory("CUSL-EasyReqPU");
        EntityManager em = emf.createEntityManager();
        em.getTransaction().begin();
        try {
            Evento ev=em.find(Evento.class,evt.getId());
            ev.setDescripcion(evt.getDescripcion());
            if(evt.isTipo())ev.setNum_paso(evt.getNum_paso());
            em.getTransaction().commit();
        } catch (Exception e) {
            e.printStackTrace();
            em.getTransaction().rollback();
        } finally {
            em.close();
        }
    }

    /**
     * @return the id
     */
    public long getId() {
        return id;
    }

    /**
     * @param id the id to set
     */
    public void setId(long id) {
        this.id = id;
    }

}
